// pdfx64.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <stdio.h>
#include <tchar.h>
#include "pdffuncs.h"

static pdfshell2::_shellExe *pdfptr = NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	if(ul_reason_for_call == DLL_PROCESS_ATTACH)
	{
	}
	else if(ul_reason_for_call == DLL_PROCESS_DETACH)
	{
	}

    return TRUE;
}
int __stdcall VeryInitializeLibrary()
{
	if(pdfptr)
		return 0;
	::CoInitialize(NULL);
	
	CLSID clsid;
	HRESULT hr;
	hr = CLSIDFromProgID(OLESTR("pdfshell2.shellExe"),&clsid);
	if (FAILED(hr))
	{
		return -1;
	}
	hr = CoCreateInstance(clsid,NULL,CLSCTX_LOCAL_SERVER,__uuidof(pdfshell2::_shellExe),(LPVOID *)&pdfptr);
	if (FAILED(hr))
	{
		return -2;
	}
	return 0;
}
void __stdcall VeryUninitializeLibrary()
{
	if(pdfptr == NULL)
		return;
	if(pdfptr)
		pdfptr->Release();//Release
	pdfptr = NULL;
	::CoUninitialize();
}
long __stdcall VeryCreate(char *filename)
{
	return pdfptr->com_VeryCreate(filename);
}
long __stdcall VeryOpen(char *filename)
{
	return pdfptr->com_VeryOpen(filename);
}
long __stdcall VeryAddImage(long id,char *filename)
{
	return pdfptr->com_VeryAddImage(id, filename);
}
int __stdcall VerySplitMergePDF(char *lpCommandLine)
{
	return pdfptr->com_VerySplitMergePDF(lpCommandLine);
}
long __stdcall VeryStampLayerOpen(char *In,char *Out,char *lpFGLayerName,char *lpBGLayerName)
{
	return pdfptr->com_VeryStampLayerOpen(In, Out, lpFGLayerName, lpBGLayerName);
}
void __stdcall VeryClose(long id)
{
	pdfptr->com_VeryClose(id);
}
long __stdcall VerySetFunction(long id,long code,long para1,long para2,char *para3,char *para4)
{
	return pdfptr->com_VerySetFunction(id, code, para1, para2, para3, para4);
}
long __stdcall VeryGetFunction(long id,long code,long para1,long para2,char *para3,char *para4)
{
	return pdfptr->com_VeryGetFunction(id, code, para1, para2, para3, para4);
}
long __stdcall VeryStampOpen(char *In,char *Out)
{
	return pdfptr->com_VeryStampOpen(In, Out);
}
void __stdcall VeryStampClose(long id)
{
	pdfptr->com_VeryStampClose(id);
}
long __stdcall VeryStampGetFunction(long id,long code,long para1,long para2,char *para3,char *para4)
{
	return pdfptr->com_VeryStampGetFunction(id, code, para1, para2, para3, para4);
}
long __stdcall VeryStampSetFunction(long id,long code,long para1,long para2,char *para3,char *para4)
{
	return pdfptr->com_VeryStampSetFunction(id, code, para1, para2, para3, para4);
}
long __stdcall VeryStampAddImage(long id,long position, char *filename,
							long shift_lr,long shift_tb,long rotate,long layer,
							long zoomW,long zoomH,
							long action,char *link,long pageno)
{
	return pdfptr->com_VeryStampAddImage(id, position, filename,
							shift_lr, shift_tb, rotate, layer,
							zoomW, zoomH, action, link, pageno);
}
long __stdcall VeryStampAddImageEx(long id,long position, char *filename,
							long shift_lr,long shift_tb,long rotate,long layer,
							long width,long height,
							long action,char *link,long pageno)
{
	return pdfptr->com_VeryStampAddImageEx(id, position, filename,
							shift_lr, shift_tb, rotate, layer,
							width, height, action, link, pageno);
}
long __stdcall VeryStampAddText( long id,long position, 
				char *stringA,long color,long alignment,
				long shift_lr,long shift_tb,long rotate,long layer,long hollow,
				long fontcode,char *fontname,long fontsize,
				long action,char *link,long pageno)
{
	return pdfptr->com_VeryStampAddText(id, position, 
				stringA, color, alignment, shift_lr, shift_tb, rotate, layer, hollow,
				fontcode, fontname, fontsize, action, link, pageno);
}
long __stdcall VeryStampAddLine(long id,long position, long width,long color,
							long shift_lr,long shift_tb,long rotate,long layer,
							long zoomW,long zoomH)
{
	return pdfptr->com_VeryStampAddLine(id, position,  width, color,
							shift_lr, shift_tb, rotate, layer,
							zoomW, zoomH);
}
long __stdcall VeryStampAddRect(long id,long sx,long sy,long ex,long ey, long side_width,long side_color, long flagFill,long fill_color)
{
	return pdfptr->com_VeryStampAddRect(id, sx, sy, ex, ey,  side_width, side_color,  flagFill, fill_color);
}
int __stdcall VeryRepairPDF(char *input, char *output)
{
	return pdfptr->com_VeryRepairPDF(input, output);
}
long __stdcall VeryStampAddLineEx(long id,long sx,long sy,long ex,long ey,long width,long color)
{
	return pdfptr->com_VeryStampAddLineEx(id, sx, sy, ex, ey, width, color);
}
int __stdcall VeryGetPDFFileMediaBox(const char *input, int pagenum,float *left,float *top, float *right, float *bottom)
{
	return pdfptr->com_VeryGetPDFFileMediaBox(input, pagenum, left, top, right, bottom);
}
long __stdcall ImageStampOpen(char *In,char *Out)
{
	return pdfptr->com_ImageStampOpen(In, Out);
}
void __stdcall ImageStampClose(long id)
{
	pdfptr->com_ImageStampClose(id);
}
long __stdcall ImageStampAddText( long id, int x, int y, char *text,long color,struct pdfshell2::LOGFONT font,int style)
{
	return pdfptr->com_ImageStampAddText_VB(id, x, y, text, color,style, font.lfHeight, font.lfOrientation, (char*)font.lfFaceName);
}
long __stdcall ImageStampAddImage(long id,int x,int y, int width, int height,char *filename,
		BOOL bTransparent)
{
	return pdfptr->com_ImageStampAddImage(id, x, y, width, height, filename, bTransparent);
}
long __stdcall ImageStampGetInfo(long id,struct pdfshell2::BITMAPINFOHEADER *lpbi)
{
	return pdfptr->com_ImageStampGetInfo(id,lpbi);
}
long __stdcall ImageStampPrint(long id, const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies)
{
	return pdfptr->com_ImageStampPrint(id, ptrPrintName, dmOrientation, dmPaperSize, dmCopies);
}
long __stdcall ImageStampSetPageRange(long id, char *lpPageRange)
{
	return pdfptr->com_ImageStampSetPageRange(id, lpPageRange);
}
void __stdcall ImageStampCloseAndNotSave(long id)
{
	pdfptr->com_ImageStampCloseAndNotSave(id);
}
long __stdcall ImageStampShow(long id, HDC hDC,struct pdfshell2::RECT *rcDst, struct pdfshell2::RECT *rcSrc)
{
	struct pdfshell2::BITMAPINFOHEADER bmbi;
	ImageStampGetInfo(id, &bmbi);
	struct pdfshell2::RECT destRect;
	struct pdfshell2::RECT srcRect;
	srcRect.left = 0;
	srcRect.top = 0;
	srcRect.right = bmbi.biWidth;
	srcRect.bottom = bmbi.biHeight;
	destRect = srcRect;
	if(rcDst)
		destRect = *rcDst;
	if(rcSrc)
		srcRect = *rcSrc;
	
	int nBufLen = ImageStampGetDIBLength(id);
	VARIANT nDIBData;
	VariantInit(&nDIBData);
	long nRet = ImageStampGetDIB(id, &nDIBData);
	if(nRet > 0)
	{
		char *lpDIBData = NULL; 
		long plLbound, plUbound; 
		SAFEARRAY *parrTemp = nDIBData.parray; 
		HRESULT hr = SafeArrayAccessData (parrTemp, (void **)&lpDIBData); 
		if (!FAILED(hr) && lpDIBData)
		{ 
			SafeArrayGetLBound (parrTemp, 1, &plLbound); 
			SafeArrayGetUBound (parrTemp, 1, &plUbound); 
			int nDIBDataLen = plUbound-plLbound+1; 
			if (nDIBDataLen > 0) 
			{
				nRet = ::StretchDIBits(hDC, destRect.left, destRect.top, 
					destRect.right-destRect.left, destRect.bottom-destRect.top,
					srcRect.left, srcRect.top, srcRect.right-srcRect.left, srcRect.bottom-srcRect.top,
					lpDIBData, (LPBITMAPINFO) &bmbi, DIB_RGB_COLORS, SRCCOPY);
			} 
			SafeArrayUnaccessData (parrTemp);
			SafeArrayDestroy(parrTemp);
		} 
	}
	return TRUE;
}
long __stdcall ImageStampGetDIBLength(long id)
{
	return pdfptr->com_ImageStampGetDIBLength(id);
}
long __stdcall ImageStampGetDIB(long id, VARIANT *lpDIBData)
{
	return pdfptr->com_ImageStampGetDIB(id, lpDIBData);
}
void __stdcall ImageStampSetLibDirectoryName(const char *ptrLibDirectory)
{
	pdfptr->com_ImageStampSetLibDirectoryName(ptrLibDirectory);
}
long __stdcall ImageStampAddLine( long id, int x0, int y0, int x1, int y1, 
				 int width,long color,int style)
{
	return pdfptr->com_ImageStampAddLine(id, x0, y0, x1, y1, 
				 width, color, style);
}
HDC __stdcall ImageStampGetHDC( long id)
{
	return (HDC)pdfptr->com_ImageStampGetHDC(id);
}
long __stdcall ImageStampReleaseHDC( long id, HDC hDC)
{
	return pdfptr->com_ImageStampReleaseHDC(id, (LONG)hDC);
}
long __stdcall VeryShellPrintPDFFileTimeOut(DWORD dwMilliseconds)
{
	return pdfptr->com_VeryShellPrintPDFFileTimeOut(dwMilliseconds);
}
long __stdcall VeryShellPrintPDFFileMargins(long lMargins)
{
	return pdfptr->com_VeryShellPrintPDFFileMargins(lMargins);
}
long __stdcall ImageStampAddText_VB( long id, int x, int y, char *text,long color,int style,
	int nPointSize,int nOrientation,char* lpszFaceName)
{
	return pdfptr->com_ImageStampAddText_VB(id, x, y, text,color,style,
		nPointSize, nOrientation,lpszFaceName);
}
long __stdcall ImageStampPrintEx(long id, const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies,
								 int bShellPrint)
{
	return pdfptr->com_ImageStampPrintEx(id, ptrPrintName, dmOrientation,  dmPaperSize, dmCopies, bShellPrint);
}

int __stdcall VeryPrintPDFFile(const char *lpPDFFileName,const char *ptrPrintName,
							   long dmOrientation, long dmPaperSize,long dmCopies)
{
	return pdfptr->com_VeryPrintPDFFile(lpPDFFileName, ptrPrintName,
							   dmOrientation, dmPaperSize, dmCopies);
}
int __stdcall VeryRunCommand(char *szCommand, long para1,long para2,char *para3,char *para4)
{
	return pdfptr->com_VeryRunCommand(szCommand, para1, para2, para3, para4);
}
long __stdcall VeryShellPrintPDFFileEx(const char *lpPDFFileName,const char *ptrPrintName,
						  long dmOrientation, long dmPaperSize,long dmCopies,int bShellPrint)
{
	return pdfptr->com_VeryShellPrintPDFFileEx(lpPDFFileName, ptrPrintName,
						  dmOrientation, dmPaperSize, dmCopies,bShellPrint);
}
long __stdcall VeryShellPrintPDFFile(const char *lpPDFFileName,const char *ptrPrintName,
						  long dmOrientation, long dmPaperSize,long dmCopies)
{
	return pdfptr->com_VeryShellPrintPDFFile(lpPDFFileName,ptrPrintName,
						  dmOrientation, dmPaperSize, dmCopies);
}
long __stdcall VeryAddInfo (long id, char * Title, char * Subject,char * Author,char * Keywords,char * Creator)
{
	return pdfptr->com_VeryAddInfo (id, Title, Subject, Author, Keywords, Creator);
}

long __stdcall VeryAddInfoEx (long id, char *key, char *value, int iLen)
{
	return pdfptr->com_VeryAddInfoEx (id, key, value, iLen);
}
long __stdcall VeryStampAddRectWithLayer(long id,long sx,long sy,long ex,long ey, long side_width,
				    long side_color, long flagFill,long fill_color,long layer)
{
	return pdfptr->com_VeryStampAddRectWithLayer(id,sx,sy,ex,ey,side_width,
				    side_color,flagFill,fill_color,layer);
}
long __stdcall VeryStampReg(char *reg)
{
	return pdfptr->com_VeryStampReg(reg);
}
long __stdcall VeryStampUndo(char *filename)
{
	return pdfptr->com_VeryStampUndo(filename);
}
int __stdcall VeryGetPDFFileInfo(const char *input, char *output)
{
	return pdfptr->com_VeryGetPDFFileInfo(input, output);
}
int __stdcall VeryGetPDFFileInfoEx(const char *input, char* sTitle, char* sSubject, 
								   char* sAuthor, char* sKeywords, char* sCreator,
								   char* sProducer, char* sVersion, char* sPageCount,
								   char* sCreatedDate, char* sModifyDate)
{
	return pdfptr->com_VeryGetPDFFileInfoEx(input, sTitle, sSubject, 
								   sAuthor, sKeywords, sCreator,
								   sProducer, sVersion, sPageCount,
								   sCreatedDate, sModifyDate);
}
long __stdcall VeryAddTextEx(long id,long x,long y, char *stringA,long color)
{
	return pdfptr->com_VeryAddTextEx(id,x,y, stringA,color);
}
long __stdcall VeryAddText(long id,long x,long y,long width,long height, char *stringA,long color,long bkcolor,long lFormat)
{
	return pdfptr->com_VeryAddText(id,x,y,width,height,stringA,color,bkcolor,lFormat);
}
long __stdcall VeryAddTxt(long id,char *filename,long color,
			long PageWidth,long PageHeight,long AutoNewLine,long AutoWidthAdjust,
			long LeftMargin,long RightMargin,long TopMargin,long BottomMargin,
			long TabSize)
{
	return pdfptr->com_VeryAddTxt(id,filename,color,
			PageWidth,PageHeight,AutoNewLine,AutoWidthAdjust,
			LeftMargin,RightMargin,TopMargin,BottomMargin,
			TabSize);
}
long __stdcall VeryAddLine(long id,long sx,long sy,long ex,long ey,long width,long color)
{
	return pdfptr->com_VeryAddLine(id,sx,sy,ex,ey,width,color);
}
long __stdcall VeryAddRect(long id,long sx,long sy,long ex,long ey,
			long side_width,long side_color,
			long flagFill,long fill_color)
{
	return pdfptr->com_VeryAddRect(id,sx,sy,ex,ey,
			side_width,side_color,
			flagFill,fill_color);
}
long __stdcall VeryAddCircle(long id,long x,long y, long radius,
			long side_width,long side_color,
			long flagFill,long fill_color)
{
	return pdfptr->com_VeryAddCircle(id,x,y, radius,
			side_width,side_color,
			flagFill,fill_color);
}
long __stdcall VeryAddEllipse(long id,long sx_,long sy_,long ex_,long ey_,
			long side_width,long side_color,
			long flagFill,long fill_color)
{
	return pdfptr->com_VeryAddEllipse(id,sx_,sy_,ex_,ey_,
			side_width,side_color,
			flagFill,fill_color);
}
long __stdcall VeryAddPolygon(long id,struct pdfshell2::POINT * lpPoints, int nCount,
			long side_width,long side_color,
			long flagFill,long fill_color)
{
	return pdfptr->com_VeryAddPolygon(id, lpPoints,  nCount,
			 side_width, side_color,
			 flagFill, fill_color);
}
long __stdcall VeryAddCurveTo(long id,long sx_,long sy_,long x1,long y1,
			long x2,long y2,long x3,long y3,
			long side_width,long side_color)
{
	return pdfptr->com_VeryAddCurveTo( id, sx_, sy_, x1, y1,
			 x2, y2, x3, y3,
			 side_width, side_color);
}

long __stdcall VeryAddImageData(long id, char *lpImgData,long width,long height,long color/*1,8,24*/)
{
	return pdfptr->com_VeryAddImageData(id, (long)lpImgData, width, height, color);
}
int __stdcall VeryConvertImageToPDF(char *input, char *output,char *options)
{
	return pdfptr->com_VeryConvertImageToPDF(input, output, options);
}
long __stdcall VeryDecryptPDF(const char * inFileName, const char *outFileName,
			   const char *OwnerPassword, const char *UserPassword)
{
	return pdfptr->com_VeryDecryptPDF(inFileName, outFileName,
			   OwnerPassword, UserPassword);
}
BOOL __stdcall VeryIsPDFEncrypted(const char * inFileName)
{
	return pdfptr->com_VeryIsPDFEncrypted(inFileName);
}
long __stdcall VeryEncryptPDF(const char * inFileName, const char *outFileName, 
			   long EnctyptLen, long permission, 
			   const char *OwnerPassword, const char *UserPassword)
{
	return pdfptr->com_VeryEncryptPDF(inFileName, outFileName, 
			    EnctyptLen, permission, OwnerPassword, UserPassword);
}
BOOL __stdcall VeryTestEncryptedPDF(const char * inFileName,const char *OwnerPassword, 
				 const char *UserPassword)
{
	return pdfptr->com_VeryTestEncryptedPDF(inFileName, OwnerPassword, 
				 UserPassword);
}
int __stdcall VeryAppendPDF(char *ptrExistingPDFName,char *ptrAppendPDF)
{
	return pdfptr->com_VeryAppendPDF(ptrExistingPDFName,ptrAppendPDF);
}
int __stdcall VerySplitMergePDFEx(char *lpInputPDF,char *lpPageRange,char *lpOutPDF)
{
	return pdfptr->com_VerySplitMergePDFEx(lpInputPDF,lpPageRange,lpOutPDF);
}
int __stdcall VeryMergePDFFiles(LPSTR lpMergePDFFiles, LPCTSTR lpOutPDF)
{
	return pdfptr->com_VeryMergePDFFiles(lpMergePDFFiles, lpOutPDF);
}
int __stdcall VeryGetPDFFilePageCount(const char *lpInputPDF)
{
	return pdfptr->com_VeryGetPDFFilePageCount(lpInputPDF);
}
int __stdcall VeryGetPDFFilePageCount2(const char *lpInputPDF)
{
	return pdfptr->com_VeryGetPDFFilePageCount2(lpInputPDF);
}
int __stdcall VeryGetPDFFilePageCountFast(const char *lpInputPDF)
{
	return pdfptr->com_VeryGetPDFFilePageCountFast(lpInputPDF);
}

int __stdcall TIFFImageGetPageCount(char *inputTIFFFile)
{
	return pdfptr->com_TIFFImageGetPageCount(inputTIFFFile);
}
int __stdcall TIFFImageGetColors(char *inputTIFFFile, int pageno)
{
	return pdfptr->com_TIFFImageGetColors(inputTIFFFile, pageno);
}
int __stdcall TIFFImageGetCompression(char *inputTIFFFile, int pageno)
{
	return pdfptr->com_TIFFImageGetCompression(inputTIFFFile, pageno);
}
int __stdcall TIFFImageSetOptions(char *inputTIFFFile, int pageno, int colors, int compression)
{
	return pdfptr->com_TIFFImageSetOptions(inputTIFFFile, pageno, colors, compression);
}